# ml defination
import os.path,sys,math,glob,datetime,re,random,itertools,time,sqlconn,zscale
sys.path.append('/home/gwpadova/scripts/gw/ec_version/gws')
import gw_util

from astropy.io import fits
from astropy.table import Table
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import pylab as pl
from astropy import wcs as pywcs
from matplotlib.ticker import NullFormatter,MultipleLocator, FormatStrFormatter
import matplotlib.gridspec as gridspec
import matplotlib.patches as patches

from sklearn import (linear_model,clone,mixture)
from sklearn.model_selection import train_test_split
from sklearn.metrics import confusion_matrix
from sklearn.tree import DecisionTreeClassifier
from sklearn.ensemble import (RandomForestClassifier, ExtraTreesClassifier,
                              AdaBoostClassifier)
from sklearn.decomposition import PCA
from sklearn.discriminant_analysis import LinearDiscriminantAnalysis
from sklearn.svm import SVC
from sklearn.naive_bayes import GaussianNB
from sklearn.neighbors import KNeighborsClassifier
from sklearn.cluster import KMeans

from sklearn.externals import joblib
from astroML.utils import completeness_contamination
from jd_calculator import datetime_to_jd

def getlist(trigger,pointing):
    imglist = {}
    reObj = re.compile('epoch')
    command = ["select * from difflist_"+trigger]
    data = sqlconn.query(command,sqlconn.conn)
    for d in data:
        lra,ldec = str(d['ra0']),str(d['dec0'])
        if pointing:
            radec = pointing.split(',')
            if [lra,ldec] != radec: continue
        imglist[lra,ldec]={}
        for n in d:
            if(reObj.match(n)):
                if str(d[n])!='None':
                    date_new = n[5:][:4]+'-'+n[5:][4:6]+'-'+n[5:][6:]
                    imglist[lra,ldec][date_new]= d[n]
    return imglist

def build_ML_database(_usr,dataou,trigger,filtro):    
    #classification id
    ## 1 ##
    _map1 = {0:'bogus',1:'real'}
    
    ## 2 ##
    _map2 = {}
    command = ['select * from classification where ML_id!=-999']
    data= sqlconn.query(command, sqlconn.conn)
    for ii in data:
        if ii['ML_id'] is None:continue
        _map2[ii['abbreviation']] = ii['ML_id']
   
    # Use candidates table info
    for _cl1,_cl2 in zip(_map2.keys(),_map2.values()):       
        command = ['select * from GW_classify_'+_usr+\
                   ' where '+str(_cl1)+'=1']         
        lista = sqlconn.query(command,sqlconn.conn)      
        for line0 in lista: 
            _tname = line0['triggername']   
            if trigger:
                if _tname == trigger:pass
                else:continue    
            if 'vstname' in gw_util.triggerlist[_tname]:
                _tname1 = _tname+'_VST'
            else:
                _tname1=_tname
            _num = line0['number']  
            command1 = ['select * from candidates_'+_tname+' where number='+str(_num)]          
            data = sqlconn.query(command1,sqlconn.conn)                            
            if len(data):                      
                for line in data:     
                    date_new = line['date_new']
                    date_ref = line['date_ref']
                    pointing = line['pointing']
                    command2 = ["select * from difflist_"+_tname+" where pointing='"+str(pointing)+"'"]            
                    data2 = sqlconn.query(command2,sqlconn.conn)                                          
                    if gw_util.triggerlist[_tname]['pointing'] == 'pnumber':
                        pointing1 = 'p'+str(data2[0]['pointing'])
                    elif gw_util.triggerlist[_tname]['pointing'] == 'ra,dec':                      
                        pointing1 = str(data2[0]['ra0'])+'_'+str(data2[0]['dec0'])                                            
                    else:sys.exit('trigger to be defined')                                      

                    fdir_n = dataou+_tname+'/'
                    _fpath = fdir_n+date_new+'/'                                                         
                    _fname = '_'.join(['diff',_tname1,filtro,date_new.replace('-',''),\
                                           date_ref.replace('-',''),pointing1])                    
                    command0 = ["select * from ML_candidates where filepath='"+_fpath+\
                                    "' and filename='"+_fname+"' and abs(xpos-"+str(line['coox'])+\
                                    ")<0.1 and abs(ypos-"+str(line['cooy'])+")<0.1"]
                    data0 = sqlconn.query(command0,sqlconn.conn)           
                    if len(data0) == 0:pass
                    else:
                        print('already')
                        continue
                    dictionary = {                         
                        'class':_map1[_cl2],                        
                        'xpos':str(line['coox']),
                        'ypos':str(line['cooy']),                      
                        'filename':_fname,
                        'filepath':_fpath}
                    print(dictionary)                        
                    sqlconn.insert_values(sqlconn.conn,'ML_candidates',dictionary)

def decide_size(sizelist,verbose): 
    answ = input('style:1 or 2?')
    if answ == '1':chs = True
    elif answ == '2':chs = False
    else:sys.exit('...')

    matrixlist,labellist,answ = [],[],''
    import matplotlib.patches as patches  
    colorlist = ['r','k','y','g','b']
    pl.ion()
    plt.figure(0)
    plt.figure(1)
    f,axes = plt.subplots(len(sizelist))

    command = ['select * from ML_candidates']
    lista = sqlconn.query(command,sqlconn.conn)
    lista = lista[:100]
    for nn,line0 in enumerate(lista):         
        print(nn,'of',len(lista))       
        img = line0['filepath']+line0['filename']+'.fits'          
        cx = line0['xpos']
        cy = line0['ypos'] 
        _cl = line0['class']       
        matrix = read_fits(img,cx,cy,max(sizelist)+4)        
        if len(matrix)==0:continue
        nmatrix = norm_matrix(matrix)   # normalizaion the matrix    

        matrixlist.append(nmatrix[0])
        if _cl == 'real':labellist.append(1)            
        else:labellist.append(0)            

        if answ=='Q':continue   
        dx,dy = nmatrix[0].shape  
         
        if chs:
            ax,ax1,ax2 = scatter_hist(nmatrix[0],_cl,dx,dy,'gray',0)
        else:
            ax = counts_show(nmatrix[0],_cl,'gray',-2,2.5,0)
        for _nn,size in enumerate(sizelist):     
            _color = colorlist[_nn]
            ##
            _matrix = read_fits(img,cx,cy,size) 
            _dx,_dy = _matrix[0].shape  
            axes[_nn].imshow(_matrix.reshape(_dx,_dy))
            ##
            p = patches.Rectangle((dx/2-size/2,dy/2-size/2),size,size,\
                                  fill=False,edgecolor=_color)
            ax.add_patch(p)     
        
        if chs:ax.set_axis_off()
        answ = input('Q?')               
        ax.cla()
        if chs:
            ax1.cla()
            ax2.cla()        
    plt.clf()
    plot_Xy(np.array(matrixlist),np.array(labellist),True,verbose)
    input('...')

def create_npz(memodir,_size,clobber):          
    # define filename with size
    npzfile = str(_size)+'.npz'

    # check if memory exists for special model,params and size
    ## choose model and params
    npzpath,npzfile,_id = check_memory_npz(_size,'stamps')           
    if npzfile:
        if clobber:
            command = ['delete from ML_memory where id='+str(_id)+' limit 1']
            sqlconn.query(command,sqlconn.conn)      
            os.remove(npzpath+npzfile)
        else:
            answ = input('npz with '+str(_size)+' already, still create?(Y)')
            if answ == 'Y':pass
            else:return

    # read images and labels
    matrixlist = []  
    label = [] 
    command = ['select * from ML_candidates']
    lista = sqlconn.query(command,sqlconn.conn)      
    for nn,line0 in enumerate(lista):              
        img = line0['filepath']+line0['filename']+'.fits'
        cx = line0['xpos']
        cy = line0['ypos'] 
        _cl = line0['class']       
        matrix = read_fits(img,cx,cy,_size)         

        # to be considered!!!!
        # normalize here, or later.
        # remember: normalize only once!!!
        if len(matrix)>0:nmatrix = norm_matrix(matrix)   # normalizaion the matrix       
        matrixlist.append(nmatrix[0])     
        label.append(_cl)     
        print(nn,'of',len(lista))
    X,y = np.array(matrixlist), np.array(label)  

    # store data to npz
    np.savez(memodir + npzfile, X=X, y=y)
   
    # store to database
    dictionary = {  
        'type':'npz',
        'filename':str(npzfile),           
        'filepath':str(memodir),                               
        'length':str(len(lista)),
        'size':str(_size)}
    sqlconn.insert_values(sqlconn.conn,'ML_memory',dictionary)

def create_npz_p(memodir,clobber):          
    # define filename with size
    npzfile = 'sex.npz'

    # check if memory exists for special model,params and size
    ## choose model and params
    if False:
        npzpath,npzfile,_id = check_memory_npz(_size,'parameters')           
        if npzfile:
            if clobber:
                command = ['delete from ML_memory where id='+str(_id)+' limit 1']
                sqlconn.query(command,sqlconn.conn)      
                os.remove(npzpath+npzfile)
            else:
                answ = input('npz with '+str(_size)+' already, still create?(Y)')
                if answ == 'Y':pass
                else:return

    # read images and labels
    _globlist = {'GW170814':'/data01/padova/PDdiff/GW170814/global/global_GW170814_r.fits',
                 'G211117':'/data01/padova/PDdiff/G211117/global/global_G211117_r_all.fits',
                 'G184098':'/data02/padova/PDdiff/G184098/global/global_G184098_r.fits'}
    _tablist = {}
    for _gg in _globlist:
        _tablist[_gg] =  Table.read(_globlist[_gg],format='fits')   

    matrixlist = []
    _keys = []  
    for _zz in ['dif','new','ref']:
        for _pp in open('/home/gwpadova/scripts/gw/ec_version/gws/default/default.param').readlines():
            if len(_pp)>1 and _pp[0]!='#':
                _keys.append(_pp.split('\n')[0].replace('(','_').replace(')','')+'_'+_zz)      
    label = [] 
    command = ['select * from ML_candidates']
    lista = sqlconn.query(command,sqlconn.conn)      
    for nn,line0 in enumerate(lista):              
        matrix = []
        img = line0['filepath']+line0['filename']+'.fits'
        cx = line0['xpos']
        cy = line0['ypos'] 
        _cl = line0['class']       
        _trigger = os.path.basename(img).split('_')[1]          
        _index = np.where((abs(_tablist[_trigger]['X_IMAGE_1']-cx)<.1) & (abs(_tablist[_trigger]['Y_IMAGE_1']-cy)<.1))                      
        for _nn,_mm in enumerate(_tablist[_trigger][_index].keys()):
            if _nn>0 and _nn<len(_keys)+2 and not 'Separation' in _mm and len(_tablist[_trigger][_index][_mm])==1:                             
                matrix.append(_tablist[_trigger][_index][_mm][0])                       
        matrixlist.append(matrix)
        label.append(_cl)     
        print(nn,'of',len(lista))
    X,y,z = np.array(matrixlist), np.array(label), np.array(_keys)

    # store data to npz
    np.savez(memodir + npzfile, X=X, y=y, z=z)
   
    # store to database
    dictionary = {  
        'type':'npz',
        'filename':str(npzfile),           
        'filepath':str(memodir),                               
        'length':str(len(lista))}
    sqlconn.insert_values(sqlconn.conn,'ML_memory',dictionary)

def create_npz_s(memodir,clobber):          
    # define filename with size
    npzfile = 'rank.npz'

    # check if memory exists for special model,params and size
    ## choose model and params
    if False:
        npzpath,npzfile,_id = check_memory_npz(_size,'parameters')           
        if npzfile:
            if clobber:
                command = ['delete from ML_memory where id='+str(_id)+' limit 1']
                sqlconn.query(command,sqlconn.conn)      
                os.remove(npzpath+npzfile)
            else:
                answ = input('npz with '+str(_size)+' already, still create?(Y)')
                if answ == 'Y':pass
                else:return

    # read images and labels
    _globlist = {'GW170814':'/data01/padova/PDdiff/GW170814/global/global_GW170814_r.fits',
                 'G211117':'/data01/padova/PDdiff/G211117/global/global_G211117_r_all.fits',
                 'G184098':'/data02/padova/PDdiff/G184098/global/global_G184098_r.fits'}
    _tablist = {}
    for _gg in _globlist:
        _tablist[_gg] =  Table.read(_globlist[_gg],format='fits')   
        
    matrixlist = []
    _keys = ['Ranking']  
  
    label = [] 
    command = ['select * from ML_candidates']
    lista = sqlconn.query(command,sqlconn.conn)      
    for nn,line0 in enumerate(lista):              
        img = line0['filepath']+line0['filename']+'.fits'
        cx = line0['xpos']
        cy = line0['ypos'] 
        _cl = line0['class']       
        _trigger = os.path.basename(img).split('_')[1]          
        _index = np.where((abs(_tablist[_trigger]['X_IMAGE_1']-cx)<.1) & (abs(_tablist[_trigger]['Y_IMAGE_1']-cy)<.1))                                              
        matrixlist.append(_tablist[_trigger][_index]['Ranking'][0])
        label.append(_cl)     
        print(nn,'of',len(lista))
    X,y,z = np.array(matrixlist), np.array(label), np.array(_keys)

    # store data to npz
    np.savez(memodir + npzfile, X=X, y=y, z=z)
   
    # store to database
    dictionary = {  
        'type':'npz',
        'filename':str(npzfile),           
        'filepath':str(memodir),                               
        'length':str(len(lista))}
    sqlconn.insert_values(sqlconn.conn,'ML_memory',dictionary)

def split_npz(memodir,_size,test_size,clobber):           
    # check if memory exists
    npzpath, npzfile,_id = check_memory_npz(_size,'stamps')     
    if npzfile:
        _npz = np.load(npzpath+npzfile)

        # read data
        X = _npz['X']
        y = _npz['y']     
  
        # split data
        X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=test_size)  

        for _X,_y,_ss in zip([X_train,X_test],[y_train,y_test],['train','test']):
            # store data to npz           
            _ff = memodir + _ss + '_' + npzfile
            np.savez(_ff, X= _X, y= _y)

            # store to database
            dictionary = {  
                'type':'npz',
                'note':_ss,
                'filename':os.path.basename(_ff),           
                'filepath':str(memodir),                               
                'length':str(len(_y)),
                'size':str(_size)}
            sqlconn.insert_values(sqlconn.conn,'ML_memory',dictionary)

def create_clf(memodir,_size,_model,clobber):          
    # define filename with jd
    clffile = str(datetime_to_jd(datetime.datetime.now()))+'.clf'
   
    # check if memory exists for special model,params and size
    ## choose model and params
    model,_note,_mtype = choose_ML_model(_model)      
    _todo = check_memory_clf(_size,_model,_note)    
    if _todo:pass
    else:return

    # read npzfile
    npzpath,npzfile,_id = check_memory_npz(_size,'stamps')      
    _rr = np.load(npzpath+npzfile)
    X,y = _rr['X'],_rr['y']

    # do ML memory   
    X =  X.reshape(X.shape[0], -1)        
    clf = clone(model)
    
    # supervised or unsupervised    
    if _mtype == 'supervised':      
        clf = model.fit(X, y)  
    elif _mtype == 'unsupervised':      
        clf = model.fit(X)  
    else:
        sys.exit('model to be developed!!!')

    # store clf memory
    joblib.dump(clf,memodir + clffile)    
    
    # store to database
    dictionary = {  
        'type':'clf',
        'filename':str(clffile),           
        'filepath':str(memodir),                        
        'jd':datetime_to_jd(datetime.datetime.now()),
        'tid':str(_id),
        'size':str(_size),
        'model':str(_model),
        'note':str(_note)}
    sqlconn.insert_values(sqlconn.conn,'ML_memory',dictionary)
    return clf

def build_memory_3(area_factor):   
    fclasslist = {}
    command = ['select * from ML_feature']
    data= sqlconn.query(command, sqlconn.conn)
    for ii in data:
        print('\t',ii['feature'],ii['id'])
        fclasslist[str(ii['id'])] = ii['feature']
    print('#'*10)
    answ = input(':')
    flist = answ.split(',')
    directory = 'memory/'
    if not os.path.isdir(directory):os.mkdir(directory)
    ff = ''
    for f in flist:
        ff += f+'_'
    Xy_raw_file_name = directory + 'Xy_raw_'+str(ff)+str(area_factor)+'.npz'   
    print("Creating X and y in {}".format(Xy_raw_file_name))
    X, y = [], []    
    command = ['select * from ML_candidates as m join candidates as c where m.imgid=c.id']
    lista = sqlconn.query(command,sqlconn.conn)  
    for nn,line0 in enumerate(lista):   
        for f in flist:        
            if f == '1':     
                img = line0['filepath']+line0['filename']           
                cx = line0['xpos']
                cy = line0['ypos']                         
                X1 = read_fits(img,cx,cy,area_factor)
                if len(X1)>0:
                    X.append(X1)    
                    y.append(line0['classificationid'])   
            else:
                X.append(line0[fclasslist[f]])
            input(X)
            print(nn,'of',len(lista))
    X,y = np.array(X), np.array(y, dtype=np.int8)  
    np.savez(Xy_raw_file_name, X=X, y=y)
    print('Done!')

def norm_matrix(matrix):
    sigma = np.std(matrix)
    abs_matrix = abs(matrix)   
    norm_matrix = matrix/abs_matrix*np.log(1+abs_matrix/sigma)
    return np.nan_to_num(norm_matrix)

def eyeball_memory(area_factor,num):   
    # eyeball ML_candidates database and update class var
    # choose candidates condition
    if True:
        # all
        command = ['select * from ML_candidates']
    else:
        # .......as you want
        command = ['select * from ML_candidates where class='+\
                       str(input('which candidates to eyeball(real/bogus)'))]
    data= sqlconn.query(command, sqlconn.conn)

    # select randomly 
    data = random.sample(data,num)
   
    for line in data:       
        imgdiff = line['filepath']+line['filename']+'.fits'
        xx = line['xpos']
        yy = line['ypos']
        eyeballing(imgdiff,xx,yy,area_factor)
        answ = input(str(line['id'])+':'+line['class']+'? (Y/N/Q)')
        if answ == 'Q':
            sys.exit('finished eyeballing!')
        elif answ == 'N':
            # updatevalues in the table with the one user given
            _label = change_label(line['class'])
            command = ["update ML_candidates set class_eyeball='"+_label+"' where id="+str(line['id'])]
            sqlconn.query(command, sqlconn.conn)           
        
def read_fits(file_name,cx,cy,area_factor):
    area_factor = int(area_factor/2)   
    if not os.path.exists(file_name):return ''
    with fits.open(file_name) as hdulist:        
        for hdu in hdulist:                    
            cx,cy = int(round(cx)),int(round(cy))
            cxmax = cx+area_factor
            cxmin = cx-area_factor
            cymax = cy+area_factor
            cymin = cy-area_factor
            limx,limy = hdu.data.shape
            if cxmin>=0 and cxmax<=limx and cymin>=0 and cymax<=limy:
                X = np.array([hdu.data[cymin:cymax,cxmin:cxmax]])
            else:X=''          
    return X

def ml_judge_su(_npzfile,_model,test_size,train_size,verbose,nmodel,_note,_npznote):            
    _npz = np.load(_npzfile)

    # read data
    X = _npz['X']
    y = _npz['y']     

    if _npznote == 'stamps':
        # flatten data  
        num,dimx,dimy = X.shape[0],X.shape[1],X.shape[2]
        X =  X.reshape(num, -1)   
    elif _npznote == 'parameters':          
        if True:
            _wlist = np.concatenate((_npz['z'][2:20],_npz['z'][22:30],_npz['z'][31:34]))          
#            X = np.append(X[:,2:20],X[:,22:34],axis=1)
            X = np.append(np.append(X[:,2:20],X[:,22:30],axis=1),X[:,31:34],axis=1)
        else:     
            _wlist = _npz['z'][:34]
            X = X[:,:34]         
        input(X.shape)
    elif _npznote == 'score':             
        y_prob = X
        y_test = y      
        if verbose:
            # fpr vs mdr plot
            pl.ion()         
            _oo = open(_npzfile.replace('.npz','')+'_'+str(nmodel)+'_'+\
                           _note.replace('/','_')+'.merit','w')
            _oo.write('#mdr fpr '+str(train_size)+'\n')
            mdrlist,fprlist,tslist,answ = [],[],[],''          
            _range = np.arange(0,100,1)
            for ydiff in _range:            
                mdr,fpr = hist_plot(y_prob,y_test,ydiff,verbose)            
                print(mdr,fpr)
                _oo.write(str(mdr)+' '+str(fpr)+'\n')
                mdrlist.append(mdr)
                fprlist.append(fpr)    
#                tslist.append(ydiff)
                if answ == 'Y':continue
                answ = input('continue(Y/N)')
            plt.clf()
            plt.plot(mdrlist,fprlist,'-')
#            for i, txt in enumerate(tslist):
#                print(txt, (mdrlist[i], fprlist[i])) 
#                pl.annotate(txt, (mdrlist[i], fprlist[i]))           
            plt.legend(prop={'size': 10})
            plt.xlabel('MDR')
            plt.ylabel('FPR')   
            input('...')
            plt.clf()  
            _oo.close()   
        return
    else:sys.exit('...')    

    if False:
        # normalizaion the matrix
        Xn = norm_matrix(X)
    else:
        Xn = X

    # split data
    if True:
        if False:
            nreal,nbogus = 4159, 4159 #22612#63666           
            _ireal = random.sample(np.where(y=='real')[0],nreal)
            _ibogus = random.sample(np.where(y=='bogus')[0],nbogus)
            Xn, y = Xn[_ireal+_ibogus], y[_ireal+_ibogus]
        X_train, X_test, y_train, y_test = train_test_split(Xn, y, test_size=test_size, train_size=train_size)  
          
    else:               
        nreal = 10
        nbogus = 10000
        _X_train, X_test, _y_train, y_test = train_test_split(Xn, y, test_size=test_size) 
        if True:
            _ireal = random.sample(np.where(y=='real')[0],nreal)
            _ibogus = random.sample(np.where(y=='bogus')[0],nbogus)
            X_train, y_train = Xn[_ireal+_ibogus], y[_ireal+_ibogus]
        else:                     
            _ireal = list(np.append(np.repeat(np.where(_y_train=='real'),3), \
                                    random.sample(np.where(_y_train=='real')[0],nreal)))
            _ibogus = random.sample(np.where(_y_train=='bogus')[0],nbogus)      
            X_train, y_train = _X_train[_ireal+_ibogus], _y_train[_ireal+_ibogus]
           
    n_samples_train, n_samples_test, n_features = y_train.shape[0], y_test.shape[0],X_train.shape[1]
   
    # training          
    clf = _model.fit(X_train, y_train)       

    predictions = []  
    #score
    scores = clf.score(X_test, y_test)  
    print('score:',scores)

    # prediction and probabilty
    y_pred = clf.predict(X_test)
    _flag1,_flag2,_flag11 = False,False,False
    try:
        y_prob = clf.predict_proba(X_test)   
        _flag1 = True
    except:
        try:
            y_prob = clf.decision_function(X_test)  
            _flag11 = True
        except:
            input('No predict_proba')
    try:
        y_importance = clf.feature_importances_
        _flag2 = True
    except:
        input('No importance')

    if _flag1 or _flag11:
        if verbose:
            # fpr vs mdr plot
            pl.ion()         
            _oo = open(_npzfile.replace('.npz','')+'_'+str(nmodel)+'_'+\
                           _note.replace('/','_')+'.merit','w')
            _oo.write('#mdr fpr '+str(train_size)+'\n')
            mdrlist,fprlist,tslist,answ = [],[],[],''
            if _flag1:
                _range = np.arange(0,1,0.01)
            elif _flag11:
                _range = np.arange(-1.2,1.2,.1)               
            for ydiff in _range:            
                mdr,fpr = hist_plot(y_prob,y_test,ydiff,verbose)            
                print(mdr,fpr)
                _oo.write(str(mdr)+' '+str(fpr)+'\n')
                mdrlist.append(mdr)
                fprlist.append(fpr)         
                tslist.append(ydiff)
                if answ == 'Y':continue
                answ = input('continue(Y/N)')
            plt.clf()
            plt.plot(mdrlist,fprlist,'-')
            for i, txt in enumerate(tslist):               
                pl.annotate(txt, (mdrlist[i], fprlist[i]))    
            plt.legend(prop={'size': 10})
            plt.xlabel('MDR')
            plt.ylabel('FPR')   
            input('...')
            plt.clf()  
            _oo.close()           

    if _flag2:
        if verbose:           
            # feature importance plot
            pl.ion()
            if _npznote == 'stamps':
                _p = plt.imshow(y_importance.reshape(dimx,dimy),cmap='hot')
                cbra = plt.colorbar(_p,fraction=0.046,pad=0)
                plt.xlabel('x pixel')
                plt.ylabel('y pixel')
            elif _npznote == 'parameters':
                fig, ax = plt.subplots(1, 1, figsize=[6, 8])                  
                for nii,ii in enumerate(y_importance):    
                    ax.bar(nii,ii)
                ax.set_xticks(range(len(_wlist)))
                ax.set_xticklabels(_wlist,rotation=40,fontsize=5)
                plt.ylabel('importance')
            input('...')
  
    predictions.append(y_pred)
    completeness, contamination = completeness_contamination(predictions, y_test)
    print("completeness", completeness)
    print("contamination", contamination)

    if verbose:
        # confusion matrix
        cnf_matrix = confusion_matrix(y_test, y_pred)
        plt.figure(figsize=cnf_matrix.shape)
        cllist = []
        for ii,jj in zip(y_test,y_pred):
            cllist.append(ii)
            cllist.append(jj)
        classes=np.unique(cllist)
        plot_confusion_matrix(cnf_matrix, classes=classes, normalize=False)         
        input('...')
 
def ml_judge_un(_npzfile,_model,test_size,verbose,nmodel,_note,_npznote):        
    _npz = np.load(_npzfile)

    # read data
    X = _npz['X']
    y = _npz['y']  
   
    # flatten data  
    num,dimx,dimy = X.shape[0],X.shape[1],X.shape[2]
    X =  X.reshape(num, -1)   

    # normalizaion the matrix
    Xn = norm_matrix(X)
  
    # split data
#    X_train, X_test, y_train, y_test = train_test_split(Xn, y, test_size=test_size)
    X_train, X_test, y_train, y_test = train_test_split(Xn, y, test_size=0.2, train_size=0.2)    
    n_samples_train, n_samples_test, n_features = y_train.shape[0], y_test.shape[0],X_train.shape[1]
           
    # training       
    clf = clone(_model)
    clf = _model.fit(X_train)     

    predictions = []                                          
    # prediction and probabilty
    y_pred = clf.predict(X_train)
    y_dist = clf.transform(X_train)     
    _nnt = len(y_dist[0])    

    y_1 = y_dist[np.where(y_train=='real')]
    y_2 = y_dist[np.where(y_train=='bogus')]

    if False:
        for _cc in ['real','bogus']:
            print(_cc)
            for _ii in range(_nnt):            
                _check_index = set(np.where(y_train==_cc)[0]) & \
                               set(np.where(y_pred==_ii)[0])
                _ctot = np.where(y_train==_cc)[0]
                print(_ii,len(_check_index)/float(len(_ctot)))
        input('..')


    if verbose:
        # fpr vs mdr plot
        pl.ion()       
        if _nnt == 2:            
            _dr1,_dr2=[],[]
            _db1,_db2=[],[]
            for ii in y_1:                        
                _dr1.append(ii[0])
                _dr2.append(ii[1])
            for ii in y_2:           
                _db1.append(ii[0])
                _db2.append(ii[1])
            _dr1,_dr2,_db1,_db2 = np.array(_dr1),np.array(_dr2),\
                                  np.array(_db1),np.array(_db2)

            plt.plot(_db1,_db2,'k+',label='bogus')       
            plt.plot(_dr1,_dr2,'r*',label='real')                  
            plt.legend(prop={'size': 10})
            plt.xlabel('dist1')
            plt.ylabel('dist2')   
            input('...')
            plt.clf()
            
            _oo = open(_npzfile.replace('.npz','')+'_'+str(nmodel)+'_'+\
                       _note.replace('/','_')+'.merit','w')
            _oo.write('#mdr fpr \n')
            mdrlist,fprlist,answ = [],[],''
            for ydiff in np.arange(-3,3,.01):                     
                mdr,fpr = len(np.where(_dr1<_dr2+ydiff)[0])/float(len(y_1)),\
                      len(np.where(_db1>_db2+ydiff)[0])/float(len(y_2))
                print(mdr,fpr)
                _oo.write(str(mdr)+' '+str(fpr)+'\n')
            _oo.close() 

            if False:
                # distance ratio
                y_prob = []
                for ii in y_dist:
                    y_prob.append(ii[0]/sum(ii))           
                mdrlist,fprlist,answ = [],[],''
                for ydiff in np.arange(.01,1,.01):            
                    mdr,fpr = hist_plot(y_prob,y_train,ydiff,verbose)            
                    print(mdr,fpr)
                    mdrlist.append(1-mdr)
                    fprlist.append(1-fpr)
                    if answ == 'Y':continue
                    answ = input('continue(Y/N)')
            plt.clf()
            plt.plot(mdrlist,fprlist,'-')
            plt.legend(prop={'size': 10})
            plt.xlabel('MDR')
            plt.ylabel('FPR')   
            input('...')
            plt.clf()              

        if _nnt == 3:
            _dr1,_dr2,_dr3=[],[],[]
            _db1,_db2,_db3=[],[],[]
            for ii in y_1:                        
                _dr1.append(ii[0])
                _dr2.append(ii[1])
                _dr3.append(ii[2])
            for ii in y_2:           
                _db1.append(ii[0])
                _db2.append(ii[1])
                _db3.append(ii[2])
            _dr1,_dr2,_dr3,_db1,_db2,_db3=np.array(_dr1),np.array(_dr2),\
                                           np.array(_dr3),np.array(_db1),\
                                           np.array(_db2),np.array(_db3)
          
            from mpl_toolkits.mplot3d import Axes3D
            fig = plt.figure()
            ax = fig.add_subplot(111, projection='3d')           
            ax.scatter(_db1,_db2, _db3, c='k', marker='.',label='bogus')
            ax.scatter(_dr1,_dr2, _dr3, c='r', marker='.',label='real')
            plt.legend(prop={'size': 10})
            ax.set_xlabel('dist1')
            ax.set_ylabel('dist2')
            ax.set_zlabel('dist3')
            input('...')

def choose_ML_model(nmodel):  

    command = ["select * from ML_methods where id="+str(nmodel)]
    lista = sqlconn.query(command,sqlconn.conn)                    
    if len(lista) == 0: 
        sys.exit('!!! ERROR: this model not set in ML_methods !!!')
    _mabb = lista[0]['abbreviation']
    _mtype = lista[0]['function']

    command = ["select * from ML_parameters where model="+str(nmodel)]  
    lista = sqlconn.query(command,sqlconn.conn)                    
    if len(lista) == 0:
        sys.exit('no suitable parameters set in ML_paramaeters')
    else:
        _pp,_note = {1:-99,2:-99,3:-99,4:-99,5:-99},''
        for _ii in lista:
            if _ii['use'] is None:
                _pp[_ii['num']] = _ii['default']
                _note += str(_ii['default'])+'/'
            else:
                _pp[_ii['num']] = _ii['use']
                _note += str(_ii['use'])+'/'      
    models = {'DT':DecisionTreeClassifier(max_depth=float(_pp[1])),\
              'RF':RandomForestClassifier(n_estimators=int(_pp[1]), 
                                          max_features=int(_pp[2]),
                                          min_samples_leaf=int(_pp[3])),\
              'ET':ExtraTreesClassifier(n_estimators=float(_pp[1])),\
              'AB':AdaBoostClassifier(n_estimators=float(_pp[1])),\
              'SVM':SVC(gamma=float(_pp[2]), C=float(_pp[1])),
              'NB':GaussianNB(),
              'KNN':KNeighborsClassifier(n_neighbors=float(_pp[1])),
              'KM':KMeans(n_clusters=int(_pp[1]), random_state=int(_pp[2])),
              'GMM':mixture.GaussianMixture(n_components=float(_pp[1]))}
    return models[_mabb],_note,_mtype

def ml_pred(verbose,img,imgref,imgdiff,cx,cy,area_factor,clf):      
    eyeballing(img,imgref,imgdiff,cx,cy,area_factor)     
    X1 = read_fits(img,cx,cy,area_factor) 
    if len(X1)>0:X1 = norm_matrix(X1)   # normalizaion the matrix
    X_test =  X1.reshape(1, -1)                     
    y_pred = clf.predict(X_test)      
    y_prob = clf.predict_proba(X_test)         
    return y_pred,y_prob

def change_label(yy):
    if yy == 'real':return 'bogus'
    elif yy =='bogus':return 'real'
    else:sys.exit('wrong!')

def check_memory_clf(_size,_model,_note):  
    command = ["select * from ML_memory where size="+str(_size)+\
               " and model="+str(_model)+" and type='clf' and note='"+str(_note)+"'"]
    lista = sqlconn.query(command,sqlconn.conn)           
    if len(lista) == 0:
        return True
    else:
        answ = input('memory with same params has already been done, still create(Y/N)?')
        if answ == 'Y':return True
        else:return False

def check_memory_npz(_size,_note):           
    command = ["select * from ML_memory where size="+str(_size)+\
               " and type='npz' and note='"+str(_note)+"'"]  
    lista = sqlconn.query(command,sqlconn.conn)                
    if len(lista) == 0:
        sys.exit('no suitable npz...')
    elif len(lista) == 1:          
        npzpath = lista[0]['filepath']
        npzfile = lista[0]['filename']
        _id = lista[0]['id']
        return npzpath,npzfile,_id
    else:
        for _n,ll in enumerate(lista):
            print(_n,':\t',ll)
            answ = input('choose one')
            npzpath = lista[int(answ)]['filepath']
            npzfile = lista[int(answ)]['filename']
            _id = lista[int(answ)]['id']
            return npzpath,npzfile,_id

def get_memory_clf(_size,_model,_note):  
    command = ["select * from ML_memory where size="+str(_size)+\
               " and model="+str(_model)+" and type='clf' and note='"+str(_note)+"'"]
    lista = sqlconn.query(command,sqlconn.conn)           
    if len(lista) == 0:    
        sys.exit('No such clf!!!')
    elif len(lista) == 1:
        clffile = lista[0]['filepath'] + lista[0]['filename']     
        return joblib.load(clffile)
    else:
        for _n,ll in enumerate(lista):
            print(_n,':\t',ll)
        answ = input('duplicated clf!\t 1.select 2.remove')
        if answ=='1':
            answ1=input('which one?')
            clffile = lista[int(answ1)]['filepath'] + lista[int(answ1)]['filename']       
            return joblib.load(clffile)
        elif answ == '2':
            answ1=input('which one?')
            clffile = lista[int(answ1)]['filepath'] + lista[int(answ1)]['filename']   
            os.remove(clffile)
            command = ["delete from ML_memory where filepath='"+\
                           lista[int(answ1)]['filepath']+\
                           "' and filename='"+ lista[int(answ1)]['filename']+"'"] 
            sqlconn.query(command,sqlconn.conn)

def pca(memo,ncomponents):
    num,dim1,dim2 = memo['X'].shape
    _X = memo['X'].reshape(num, -1) 
    _y = memo['y']
    dim = dim1*dim2
    _clf = PCA(n_components=ncomponents).fit(_X)

    pl.ion()
    matrix = _clf.explained_variance_ratio_        
    cum = np.cumsum(matrix)          
    plt.plot(matrix,'k-')
    plt.plot(cum,'r-')
    plt.yscale('log')
    plt.legend(loc='best')
    input('...')  

############################################################
############################################################ plot
############################################################
def multi_ML(memodir,_size,_model):
    pl.ion()
    filelist = glob.glob(memodir+'*.merit')
#    filelist = glob.glob(memodir+str(_size)+'_'+str(_model)+'*.merit')
    for _ff in filelist:          
        fpr,mdr = [],[]
        for _ll in open(_ff).readlines():
            if _ll[0] != '#':
                fpr.append(float(_ll.split()[0]))
                mdr.append(float(_ll.split()[1]))
        plt.plot(fpr,mdr,'-',label=os.path.basename(_ff))
    plt.legend()
    input('...')

def scatter_hist(X,label1,dimx,dimy,cmap,_n):
    plt.figure(_n)
    x,y=[],[]   
    for dim,ii,label in zip([dimx,dimy],[x,y],['x','y']):
        for xx in range(dim):            
            if label=='x':
                ii.append(sum(X[xx,:]))
            else:
                ii.append(sum(X[:,xx]))
    x,y=np.array(x),np.array(y)  
    nullfmt = NullFormatter()         # no labels

    # definitions for the axes
    left, width = 0.1, 0.65
    bottom, height = 0.1, 0.65
    bottom_h = left_h = left + width + 0.02
    rect_scatter = [left, bottom, width, height]
    rect_histx = [left, bottom_h, width, 0.2]
    rect_histy = [left_h, bottom, 0.2, height]

    # start with a rectangular Figure  
    axScatter = plt.axes(rect_scatter)
    axHistx = plt.axes(rect_histx)
    axHisty = plt.axes(rect_histy)

    # no labels
    axHistx.xaxis.set_major_formatter(nullfmt)
    axHisty.yaxis.set_major_formatter(nullfmt)

    # the scatter plot:
    axScatter.imshow(X,cmap=cmap)
    axScatter.axis("off")
    axHistx.bar(range(dimx),x,align='center', alpha=0.5)
    axHisty.barh(range(dimy),y,align='center', alpha=0.5)
    axHistx.set_xlim(axScatter.get_xlim())
    axHisty.set_ylim(axScatter.get_ylim())
    plt.title(label1, fontsize=14, fontweight='bold')
    return axScatter,axHistx,axHisty

def counts_show(X,label,cmap,vmin,vmax,_n):  
    plt.figure(_n, figsize=(8, 8))  
    # 1          
    sub = plt.subplot(1, 2, 1)
    sub.axis("off")
    sub.imshow(X,cmap=cmap,interpolation="nearest",vmin=vmin, vmax=vmax)           
    # 2
    sub = plt.subplot(1, 2, 2)
    nn=0
    list1,list2 = [],[]
    for ii in X:
        for jj in ii:
            nn+=1
            list1.append(jj)
            list2.append(nn)
    sub.plot(list2,list1,'y.-')    
    plt.title(label, fontsize=14, fontweight='bold')     
    return sub

def plot_Xy(X,y,show,verbose):     
    vmin,vmax=0,40    
    cmap1,cmap2 = plt.cm.gray,'hot'    

    if verbose:
        # x 
        image = X
        print(X.shape,image.shape)
        input(image)
        plt.figure(figsize=(20,10))
        plt.rcParams.update({'font.size': 10})
        plt.subplot(1, 2, 1)
        plt.hist(image.min((0,2)), bins=20, log=True)
        plt.ticklabel_format(style='sci', axis='x', scilimits=(0,0))
        plt.subplot(1, 2, 2)
        plt.hist(image.max((0,2)), bins=20, log=True);
        plt.ticklabel_format(style='sci', axis='x', scilimits=(0,0))
        input('X')
        # y
        plt.hist(y, bins=np.arange(20)-0.5)
        input('y') 

def plot_confusion_matrix(cm, classes, normalize=False, title='Confusion matrix', cmap=plt.cm.Blues):
    """
    This function prints and plots the confusion matrix.
    Normalization can be applied by setting `normalize=True`.
    """
    plt.imshow(cm, interpolation='nearest', cmap=cmap)
    plt.title(title)
    plt.colorbar()
    tick_marks = np.arange(len(classes))
    plt.xticks(tick_marks, classes, rotation=45)
    plt.yticks(tick_marks, classes)

    if normalize:
        cm = (cm.astype('float') / cm.sum(axis=1)[:, np.newaxis]).round(2)
        print("Normalized confusion matrix")
    else:
        print('Confusion matrix, without normalization')

    print(cm)

    thresh = cm.max() / 2.
    for i, j in itertools.product(range(cm.shape[0]), range(cm.shape[1])):
        plt.text(j, i, cm[i, j],
                 horizontalalignment="center",
                 color="white" if cm[i, j] > thresh else "black")

    plt.tight_layout()
    plt.ylabel('True label')
    plt.xlabel('Predicted label')
    plt.show()

def plot_error(X, y, X_train, X_test, y_train, y_test):    
    # y = np.dot(X, coef)
    coef = np.linalg.lstsq(X, y)[0]
    alphas = np.logspace(-5, 1, 60)
    enet = linear_model.ElasticNet(l1_ratio=0.8)
    train_errors = list()
    test_errors = list()
    for alpha in alphas:
        enet.set_params(alpha=alpha)
        enet.fit(X_train, y_train)
        train_errors.append(enet.score(X_train, y_train))
        test_errors.append(enet.score(X_test, y_test))

    i_alpha_optim = np.argmax(test_errors)
    alpha_optim = alphas[i_alpha_optim]
    print("Optimal regularization parameter : %s" % alpha_optim)

    # Estimate the coef_ on full data with optimal regularization parameter
    enet.set_params(alpha=alpha_optim)   
    coef_ = enet.fit(X, y).coef_
    
    plt.subplot(2, 1, 1)
    plt.semilogx(alphas, train_errors, label='Train')
    plt.semilogx(alphas, test_errors, label='Test')
    plt.vlines(alpha_optim, plt.ylim()[0], np.max(test_errors), color='k',
               linewidth=3, label='Optimum on test')
    plt.legend(loc='lower left')
#    plt.ylim([0, 1.2])
    plt.xlabel('Regularization parameter')
    plt.ylabel('Performance')

    # Show estimated coef_ vs true coef
    plt.subplot(2, 1, 2)
    plt.plot(coef_, label='True coef')
    plt.plot(coef, label='Estimated coef')
    plt.legend()
    plt.subplots_adjust(0.09, 0.04, 0.94, 0.94, 0.26, 0.26)
    plt.show()

def eyeballing(img,imgref,imgdiff,xx,yy,area_factor):
    pl.ion()
    fig = pl.figure(1,figsize=(6,2))
    pl.rcParams['figure.figsize'] = 6, 2
    pl.subplots_adjust(hspace = .01)
    pl.subplots_adjust(wspace = .01)
    pl.subplots_adjust(right=0.93, top=.93,left=.07, bottom=.07)
    gs0 = gridspec.GridSpec(1, 3, wspace=.01) 
  
    _cmap = 'hot' #'gray_r'
    if os.path.isfile(img):      
        X0, hdr0 = fits.getdata(img, header=True)
        xx0=max(xx-area_factor,0)
        xx1=min(xx+area_factor,hdr0['NAXIS1'])
        yy0=max(yy-area_factor,0)
        yy1=min(yy+area_factor,hdr0['NAXIS2'])
        # find zscale min max on the stamp        
        _z1,_z2 = zscale.zscale(X0[int(yy0):int(yy1),int(xx0):int(xx1)])
        ax = fig.add_subplot(gs0[0,0])
        ax.imshow(X0[int(yy0):int(yy1),int(xx0):int(xx1)], cmap=_cmap, aspect='equal', interpolation='nearest', origin='lower',vmin=_z1, vmax=_z2)
        ax.set_xlim(0,xx1-xx0)
        ax.set_ylim(0,yy1-yy0)
        ax.add_patch(
            patches.Rectangle(
                (xx-xx0-area_factor/2.,yy-yy0-area_factor/2.),
                area_factor,
                area_factor,
                edgecolor="green",
                fill=False))
        ax.set_xticks([])
        ax.set_yticks([])              
    if os.path.isfile(imgref):
        X0, hdr0 = fits.getdata(imgref, header=True)
        xx0=max(xx-area_factor,0)
        xx1=min(xx+area_factor,hdr0['NAXIS1'])
        yy0=max(yy-area_factor,0)
        yy1=min(yy+area_factor,hdr0['NAXIS2'])
        # find zscale min max on the stamp 
        _z1,_z2 = zscale.zscale(X0[int(yy0):int(yy1),int(xx0):int(xx1)])
        ax = fig.add_subplot(gs0[0,1])
        ax.imshow(X0[int(yy0):int(yy1),int(xx0):int(xx1)], cmap=_cmap, aspect='equal', interpolation='nearest', origin='lower',vmin=_z1, vmax=_z2)
        ax.set_xlim(0,xx1-xx0)
        ax.set_ylim(0,yy1-yy0)
        ax.add_patch(
            patches.Rectangle(
                (xx-xx0-area_factor/2.,yy-yy0-area_factor/2.),
                area_factor,
                area_factor,
                edgecolor="green",
                fill=False))
        ax.set_xticks([])
        ax.set_yticks([])
######################     
        if 'SECPIX' in hdr0:
            pixelscale = hdr0['SECPIX']
        else:
            pixelscale = 0.21
                      
        if 'FWHM' in hdr0:
            seeing = hdr0['FWHM']
        else:
            sys.exit('astrometry not good')
        fwhm = seeing / pixelscale 
        print('FWHM[header]  ', fwhm, '   in pixel')

#######################                   
    if os.path.isfile(imgdiff):
        X0, hdr0 = fits.getdata(imgdiff, header=True)
        xx0=max(xx-area_factor,0)
        xx1=min(xx+area_factor,hdr0['NAXIS1'])
        yy0=max(yy-area_factor,0)
        yy1=min(yy+area_factor,hdr0['NAXIS2'])
        # find zscale min max on the stamp 
#        _z1,_z2 = zscale.zscale(X0[int(yy0):int(yy1),int(xx0):int(xx1)])
        ax = fig.add_subplot(gs0[0,2])
        ax.imshow(X0[int(yy0):int(yy1),int(xx0):int(xx1)], cmap=_cmap, aspect='equal', interpolation='nearest', origin='lower')#,vmin=_z1, vmax=_z2)
        ax.set_xlim(0,xx1-xx0)
        ax.set_ylim(0,yy1-yy0)
        ax.add_patch(
            patches.Rectangle(
                (xx-xx0-area_factor/2.,yy-yy0-area_factor/2.),
                area_factor,
                area_factor,
                edgecolor="green",
                fill=False))
        ax.set_xticks([])
        ax.set_yticks([])                              
    pl.draw()

def hist_plot(prob,flag,ydiff,verbose):        
    pp = []
    for ii in range(len(prob)):
        try:
            pp.append(prob[ii][0])
        except:
            pp.append(prob[ii])
    pp=np.array(pp)

    r_real = pp[np.where(flag=='real')]
    r_bogus = pp[np.where(flag=='bogus')]  

    if verbose:
        plt.figure(1)
        plt.hist(r_real, 50, histtype='step', color='r', label='real')  
        plt.hist(r_bogus, 50, histtype='step', color='k', label='bogus')   
#        plt.plot([ydiff,ydiff],[0,1200],'--')
        plt.legend(prop={'size': 10})
        plt.xlabel('Hypothesis')
        plt.ylabel('Frequency')   
    #   MDR,FPR
#    if float(len(np.where(r_real<ydiff)[0])) > float(len(np.where(r_real>ydiff)[0])):        
    _bogus = float(len(np.where(r_real>=ydiff)[0]))
    _real = float(len(np.where(r_bogus<ydiff)[0]))
#    else:
#        _bogus =  float(len(np.where(r_real<ydiff)[0]))
#        _real = float(len(np.where(r_bogus>ydiff)[0]))
    return _bogus/len(np.where(flag=='real')[0]),\
        _real/len(np.where(flag=='bogus')[0])    
