#!/usr/local/anaconda3/envs/sheng/bin/python
description = "> gw machine learning function  "
usage = "%prog filename or prog --type b or prog --type j"

import sys
from numpy import take, argsort, asarray, array
from optparse import OptionParser, OptionGroup
import os,re,sqlconn
from multiprocessing import Pool
from sklearn import clone
import time
from sklearn.externals import joblib
import gwmldef

# ####################################################################################

if __name__ == "__main__":
    start_time = time.time()

    parser = OptionParser(usage=usage, description=description, version="%prog 1.0")
    parser.add_option("--memory",help='clf')  
    parser.add_option("--type", dest="type", default='p', type="str",
                      help='--type: [pre] check, [c]reate memory, [b]uild dataset, [e]yeball library or [j]udge ML or [p]redict ML [m]ulti-ml \t [%default]')
    parser.add_option("--memo", dest="memo", default='1', type="int",
                      help='--memo style; [1]stamps [2]parameters [3]score \t [%default]')
    parser.add_option("--size", dest="size", default='20', type="int",
                      help='--stamp size\t [%default]')
    parser.add_option("--model", dest="model", default='2', type="int",
                      help='--model ML model selection\t\t Supervised/Classification:'+\
                      'see database \t [%default]') 
    parser.add_option("--tsize", dest="tsize", default='0.2', type="float",
                      help='--tsize test_size  \t ML parameters \t [%default]')
    parser.add_option("--tsize1", dest="tsize1", default='0.8', type="float",
                      help='--tsize1 train_size  \t ML parameters \t [%default]')
    parser.add_option("--nshow",dest="nshow",default=100,type='int',\
                      help='--nshow Number of candidates for eyeballing \t [%default]')
    parser.add_option("-c", "--clobber",action="store_true",\
                  dest='clobber',default=False,help='clobber files')
    parser.add_option("--show", action="store_true",\
                  dest='show', default=False, \
                  help='show candidates one by one \t\t\t [%default]')  
    parser.add_option("-v", "--verbose",action="store_true",\
                  dest='verbose',default=False,help='Show statistics plot')

# ####################################################################################

if __name__ == "__main__":

    option, args = parser.parse_args()
    _clf = option.memory  
    _type = option.type
    _size = option.size
    _model = option.model
    _tsize = option.tsize
    _tsize1 = option.tsize1
    _nshow = option.nshow
    _clobber = option.clobber
    _verbose = option.verbose
    _show = option.show
    if option.memo == 1:
        _npznote = 'stamps'
    elif option.memo == 2:
        _npznote = 'parameters'
    elif option.memo == 3:
        _npznote = 'score'
    else: sys.exit('...')

    datain = os.path.expandvars("$gw_datain")
    dataou = os.path.expandvars("$gw_dataou")
    memodir = os.path.expandvars("$img_datain")+'memory/'   

    _usr = 'sheng'
#    _usr = 'margherita'
    filtro = 'r'
   
    if _type == 'pre':
        # pre-check
        sizelist = [20, 30, 40, 50]
        gwmldef.decide_size(sizelist,_verbose)       
      
        # principle component anylasis
        # to be constructed!!!
        if False:
            npz = gwmldef.check_memory_1(_size)
            gwmldef.pca(npz)

    elif _type == 'b':
        # build ML DB
        # need once for initialization!       
        if False:           
            gwmldef.build_ML_database(_usr,dataou,False,filtro)
            
        # strore stamp matrix into npz, which is fast to recall
        if True:            
            if _npznote == 'stamps':
                gwmldef.create_npz(memodir,_size,_clobber)

            elif _npznote == 'parameters':
                # strore parameter matrix into npz                     
                gwmldef.create_npz_p(memodir,_clobber)

            elif _npznote == 'score':
                # strore parameter matrix into npz                
                gwmldef.create_npz_s(memodir,_clobber)            

        # split npz into training and test set
        if False:
            gwmldef.split_npz(memodir,_size,_tsize,_clobber)

    elif _type == 'c':
        # choose stamp size       
        # do ML to create memory - clf file
        # store log into ML_memory
        gwmldef.create_clf(memodir,_size,_model,_clobber) 

    elif _type == 'e':
        # eyeball ML_candidates database and update class var      
        gwmldef.eyeball_memory(_size,_nshow)

    elif _type == 'j':
        # judge
        # check memory            
        model,_note,_mtype =  gwmldef.choose_ML_model(_model)            
        npzpath,npzfile,_id =  gwmldef.check_memory_npz(_size,_npznote)        
       
        # do judge       
        if _mtype == 'supervised':      
            gwmldef.ml_judge_su(npzpath+npzfile,model,_tsize,_tsize1,\
                                         _verbose,_model,_note,_npznote)  
        elif _mtype == 'unsupervised':                
            gwmldef.ml_judge_un(npzpath+npzfile,model,_tsize,\
                                         _verbose,_model,_note,_npznote)         
        else:
            sys.exit('model to be developed!!!')
       
    elif _type == 'm':
        # multi-ML show
        gwmldef.multi_ML(memodir,_size,_model) 

    elif _type == 'p':
        # predict
        # check memory and read clf
        if _clf is None:
            model,_note,_mtype =  gwmldef.choose_ML_model(_model)           
            clf = gwmldef.get_memory_clf(_size,_model,_note)
        else:
            clf = joblib.load(_clf)              
      
        # do prediction
        if len(args) < 1:
            sys.argv.append('--help')
            print('1. gwml jd --type p trigger filter')          
            print('2. gwml xx.asc --type p')    
            print('xx.asc, format: coox cooy img + ...')
            sys.exit()              
                           
        if len(args) == 1 and 'asc' in args[0]:
            result = []
            for ii in open(args[0]).readlines():
                if ii[0]=='#':continue
                cx,cy,_fname = ii.split()[:3]
                if 'GW170814' in _fname:
                    _trigger,filtro,_datenew,_dateref,_ra,_dec = _fname.split('_')[1],\
                        _fname.split('_')[3],\
                        _fname.split('_')[4],_fname.split('_')[5],\
                        _fname.split('_')[6],_fname.split('_')[7]    
                    fnew = '_'.join(['G297595','VST',filtro,_datenew,\
                                         'gw',_ra,_dec])
                    fref = '_'.join(['G297595','VST',filtro,_dateref,\
                                         'gw',_ra,_dec])                  
                fdir_n = dataou+_trigger+'/'          
                _fpath = fdir_n+_datenew[:4]+'-'+_datenew[4:6]+'-'+_datenew[6:]+'/'                                       
                fdir_n = datain+_trigger+'/'+_datenew[:4]+'-'+_datenew[4:6]+'-'+_datenew[6:]+'/'             
                fdir_r = datain+_trigger+'/'+_dateref[:4]+'-'+_dateref[4:6]+'-'+_dateref[6:]+'/'              
                imgdiff = _fpath+_fname+'.fits'
                img = fdir_n+fnew+'.fits'
                imgref = fdir_r+fref+'.fits'                   
                y_pred,y_prob = gwmldef.ml_pred(_verbose,img,imgref,imgdiff,float(cx),float(cy),_size,clf) 
                result.append(y_prob[0][0])

            print(result)
            sys.exit()
        
        data = sqlconn.query(['select * from candidates_'+args[0]],sqlconn.conn)
#                                  +' order by ML_classification'],sqlconn.conn)
        for line in data:              
            command2 = ['select * from difflist_'+args[0]+' where pointing='+str(line['pointing'])]
            data2 = sqlconn.query(command2,sqlconn.conn)                       
            fdir_n = dataou+args[0]+'/'          
            _fpath = fdir_n+line['date_new']+'/'            
            ##
            fdir_n = datain+args[0]+'/'+line['date_new']+'/'             
            fdir_r = datain+args[0]+'/'+line['date_ref']+'/' 
            if args[0] == 'GW170814':
                _fname = '_'.join(['diff',args[0],'VST',args[1],line['date_new'].replace('-',''),\
                                       line['date_ref'].replace('-',''),str(data2[0]['ra0']),\
                                       str(data2[0]['dec0'])])
                fnew = '_'.join(['G297595','VST',filtro,line['date_new'].replace('-',''),\
                                     'gw',str(data2[0]['ra0']),str(data2[0]['dec0'])])
                fref = '_'.join(['G297595','VST',filtro,line['date_ref'].replace('-',''),\
                                     'gw',str(data2[0]['ra0']),str(data2[0]['dec0'])])        
            else:
                _fname = '_'.join(['diff',args[0],args[1],line['date_new'].replace('-',''),\
                                       line['date_ref'].replace('-',''),'p'+str(data2[0]['pointing'])])
                fnew = '_'.join([args[0],'VST',filtro,line['date_new'].replace('-',''),\
                                     'p'+str(data2[0]['pointing'])])
                fref = '_'.join([args[0],'VST',filtro,line['date_ref'].replace('-',''),\
                                     'p'+str(data2[0]['pointing'])])                    
            imgdiff = _fpath+_fname+'.fits'
            img = fdir_n+fnew+'.fits'
            imgref = fdir_r+fref+'.fits'      
            cx,cy = line['coox'],line['cooy']
          
            command0 = ["select * from ML_candidates where filepath='"+_fpath+\
                            "' and filename='"+_fname+"' and abs(xpos-"+str(cx)+\
                            ")<0.1 and abs(ypos-"+str(cy)+")<0.1"]                      
            data0 = sqlconn.query(command0,sqlconn.conn)           
            if len(data0) == 0:pass
            else:
                print('already')
                continue
          
            y_pred,y_prob = gwmldef.ml_pred(_verbose,img,imgref,imgdiff,cx,cy,_size,clf)            

            ####
            answ = input(str(y_pred[0])+'/'+str(y_prob[0][0])+'(Y/N/Q)')
            _label = str(y_pred[0])           
           
            if answ == 'Q':
                sys.exit('Quit...')
            elif answ == 'N':
                _label = gwmldef.change_label(_label)
            elif answ == 'Y':pass
            else:continue

            dictionary = {                         
                'class':_label,                        
                'xpos':str(cx),
                'ypos':str(cy),                      
                'filename':_fname,
                'filepath':_fpath}
            print(dictionary)                   
            sqlconn.insert_values(sqlconn.conn,'ML_candidates',dictionary)
            print('insert!!!')

    print("********** Completed in ",int(time.time()-start_time),"sec")
